pro Regional_meteor_ld_landsatEVI_crop_Information,EVIobsDOY_array,ldArray,DOYini_DL,DOYend_DL,DOYini_LTDG,DOYend_LTDG, $
                                     Tbase,x1x3,DOYie_LTDG,ncol,nrow,DOYarray_meteor,dir,SRArray_list,TairArray_list,EVIArray_list
  e=ENVI(/HEADLESS)

  ;common share1,SRArray_list,TairArray_list,EVIArray_list

  ;shapefile路径
  ;shapefile路径
  shape_dir=dir+'\Mixtureld.shp'
  dir1=dir+'\EVImap\'   ;子文件夹存储Landsat EVI整幅影像和裁剪好的研究区EVI影像
  dir2=dir+'\GLDAS\SR\'    ;子文件夹Cropimage存储已经裁剪好的30m分辨率GLDAS气象数据序列
  dir3=dir+'\GLDAS\Tair\'  ;子文件夹Cropimage存储已经裁剪好的30m分辨率GLDAS气象数据序列
  
  ;检测路径是否存在，如不存在则创建该路径
  test_dir1=file_test(dir1,/directory)
  if test_dir1 eq 0 then file_mkdir,dir1
  test_dir2=file_test(dir2,/directory)
  if test_dir2 eq 0 then file_mkdir,dir2
  test_dir3=file_test(dir3,/directory)
  if test_dir3 eq 0 then file_mkdir,dir3
  
  ;GLDAS2.0气象数据在R语言程序提前重采样至30m
  ;;如果没有研究区气象数据和Landsat EVI影像，则使用感兴趣区shapefile来裁剪：子例程“subset_raster_via_shapefile”
  ;#subset_raster_via_shapefile,shape_dir,dir1,dir2,dir3,Clipmap_dir,ncol,nrow
  ;print,'n_elements(Clipmap_dir) is: '
  ;print,n_elements(Clipmap_dir)
  
  ;Clipmap_dir1.txt文本存放裁剪好的Landsat EVI影像和土地利用影像路径地址
  fileEVI=dir+'\Clipmap_dir1.txt'
  Clipmap_dirEVI=[]
  line=' '
  openr,99,fileEVI
  while (not eof(99)) do begin
    readf,99,line
    Clipmap_dirEVI=[Clipmap_dirEVI,line]
  endwhile
  free_lun,99
  Clipmap_dirSR=[]
  Clipmap_dirTair=[]
  for i=1,365 do begin
    print,i
    SRdir=dir2+'Cropimage\'+strtrim(strcompress(string(i)),1)+'.img'
    Tairdir=dir3+'Cropimage\'+strtrim(strcompress(string(i)),1)+'.img'
    Clipmap_dirSR=[Clipmap_dirSR,SRdir]
    Clipmap_dirTair=[Clipmap_dirTair,Tairdir]
  endfor
  Clipmap_dir=list()
  Clipmap_dir.add,Clipmap_dirEVI
  Clipmap_dir.add,Clipmap_dirSR
  Clipmap_dir.add,Clipmap_dirTair

  ;（1）将EVI图像转换成数组，保存在 EVIArray_list和子文件夹Array
  ;（2）Landsat EVI观测日期， 保存在 EVIobsDOY_array
  EVIobsDOY_array=[]
  EVIArray_list=list()
  EVI_dir=Clipmap_dir[0]
  ;检测路径是否存在，如不存在则创建该路径
  dir4=dir+'EVImap\Cropimage\Array\'
  test_dir4=file_test(dir4,/directory)
  if test_dir4 eq 0 then file_mkdir,dir4
  for i=0,n_elements(EVI_dir)-2 do begin   ; 路径数组包含ld，所以减去2
    print,i
    raster2=e.openraster(EVI_dir[i])
    ncol=raster2.NCOLUMNS
    nrow=raster2.nrows
    idata1=raster2.getdata(SUB_RECT=[0,0,ncol-1,nrow-1])   ; SUB_RECT=[x1,y1,x2,y2]  : x1=first pixel of the columns dimension   y1=first pixel of the rows dimension  x2=last pixel of the columns dimension   y2=last pixel of the rows dimension
    EVIArray_list.add,idata1
    ;
    iEVI_dir=EVI_dir[i]
    exten=stregex(iEVI_dir,'\..+$',/EXTRACT)
    aa=file_baseName(iEVI_dir,exten)   ;裁剪后的Landsat EVI影像命名格式：EVImap_19951230.img
    bb=julday(fix(strmid(aa,11,2)), fix(strmid(aa,13,2)), fix(strmid(aa,7,4)))   ; 月、日、年
    cc=bb-julday(1,1,1995)+1
    EVIobsDOY_array=[EVIobsDOY_array,cc]
    Write_CSV,dir4+strtrim(strcompress(string(cc)),1)+'.dat',idata1
  endfor

  ;（3）土地利用数组 ldArray
  ;Clipmap_dir1.txt文本最后一个路径属于土地分类影像产品
  ldraster=e.openraster(EVI_dir[n_elements(EVI_dir)-1])
  ldArray=ldraster.getdata(SUB_RECT=[0,0,ncol-1,nrow-1])

  ;读入各种DOY信息
  read_CropInfo,dir,DOYie_DL,DOYie_LTDG,Tbase,x1x3
  DOYini_DL=DOYie_DL[0]
  DOYend_DL=DOYie_DL[1]
  DOYini_LTDG=DOYie_LTDG[0]
  DOYend_LTDG=DOYie_LTDG[1]
  ;Tbase=Tbase
  ;x1x3=x1x3
  print,"DOYie_DL is: ",DOYie_DL
  print,"DOYie_LTDG is: ",DOYie_LTDG
  print,'Tbase is: ',Tbase
  print,'x1x3 is: ',x1x3

  ;（4）将SR和Tair图像转换成数组，保存在 SRArray_list 和  TairArray_list并输出到指定文件夹
  SRArray_list=list()
  SR_dir=Clipmap_dir[1]
  TairArray_list=list()
  Tair_dir=Clipmap_dir[2]
  DOYarray_meteor=[]
  ;检测路径是否存在，如不存在则创建该路径
  ;dir5=dir+'GLDAS\SR\Cropimage\Array\'
  ;test_dir5=file_test(dir5,/directory)
  ;if test_dir5 eq 0 then file_mkdir,dir5
  ;dir6=dir+'GLDAS\Tair\Cropimage\Array\'
  ;test_dir6=file_test(dir6,/directory)
  ;if test_dir6 eq 0 then file_mkdir,dir6  
  for i=DOYini_DL-1,DOYend_DL-1 do begin
    print,i
    DOYarray_meteor=[DOYarray_meteor,i+1]
    raster3=e.openraster(SR_dir[i])
    idata2=raster3.getdata(SUB_RECT=[0,0,ncol-1,nrow-1])   ; SUB_RECT=[x1,y1,x2,y2]
    SRArray_list.add,idata2
    ;Write_CSV,dir5+strtrim(strcompress(string(i+1)),1)+'.arr',idata2
    raster4=e.openraster(Tair_dir[i])
    idata3=raster4.getdata(SUB_RECT=[0,0,ncol-1,nrow-1])   ; SUB_RECT=[x1,y1,x2,y2]
    TairArray_list.add,idata3
    ;Write_CSV,dir6+strtrim(strcompress(string(i+1)),1)+'.arr',idata3
  endfor
  ;DOYarray_meteor=[1:n_elements(SRArray_list)]

  print, 'EVIArray_list: ', n_elements(EVIArray_list)
  print, 'SRArray_list: ', n_elements(SRArray_list)
  print, 'TairArray_list: ', n_elements(TairArray_list)

  e.close
  
end


;--------------------------------------------------------------------------
pro subset_raster_via_shapefile,shape_dir,dir1,dir2,dir3,Clipmap_dir,ncol,nrow
  COMPILE_OPT IDL2   ;;更改IDL的编译配置
  e=ENVI(/HEADLESS)
  start=systime(1)
  
  dir_array=[dir1,dir2,dir3]
  Clipmap_dir=list()
  
  for j=0,n_elements(dir_array)-1 do begin
    image_files=FILE_SEARCH(dir_array[j]+'*.tif',count=numfiles)  ; j=0 指向Landsat EVI影像时序路径，匹配tif后缀格式的所有影像文件,返回为字符串数组  j=1/2 指向SR/Tair
    print,'The numer of target tif images: ',numfiles
    ;按照日期顺序1-365排序
    rootnames=File_Basename(image_files, '.tif')
    numbers=long(rootnames)
    Sortedimage_files=image_files[Sort(numbers)]
    ;裁剪影像存放路径
    jClipmap_dir=[]
    ;
    for i=0,numfiles-1 do begin
      print,i
      input=Sortedimage_files[i]
      print,input
      input_shp=shape_dir
      ;输出裁剪后的文件
      ;获取文件后缀名DISPLAY_NAME=string]
      exten=stregex(input,'\..+$',/EXTRACT)
      ouput_file=dir_array[j]+'Cropimage\'+file_baseName(input,exten)+'.img'
      ;读取栅格文件
      if input eq '' then begin
        return
      endif
      raster=e.OpenRaster(input)
      ;print,'读取栅格文件完成。。。。。'
      ;读取矢量文件
      file_shp=e.OpenVector(input_shp)
      ;print,'读取栅格文件完成。。。。。'
      Task_MASK=ENVITASK('VectorMaskRaster')
      Task_MASK.data_ignore_value=0
      Task_MASK.input_Mask_vector=file_shp
      Task_MASK.input_raster=raster
      Task_MASK.Execute
      ;print,'掩膜完成。。。。。'
      ;重新定义边界
      x=(file_shp.data_range[3]-file_shp.data_range[1])/30
      y=(file_shp.data_range[2]-file_shp.data_range[0])/30
      ;定义边界
      Grid=ENVIGridDefinition(file_shp.Coord_Sys, $
        PIXEL_SIZE=[30.0D,30.0D], $
        TIE_POINT_PIXEL=[0.0D,0.0D], $
        TIE_POINT_MAP=[file_shp.data_range[0],file_shp.data_range[3]], $
        NROWS=x, $
        NCOLUMNS=y)
      Task=ENVITask('RegridRaster')
      Task.INPUT_RASTER = Task_MASK.output_raster
      Task.GRID_DEFINITION = Grid
      Task.Execute
      Task.output_raster.Export,ouput_file,'dat'
      jClipmap_dir=[jClipmap_dir,ouput_file]  ;补充新元素 
    endfor
    Clipmap_dir.add,jClipmap_dir
    
    print,j
    ;
    rasterf=e.openraster(ouput_file)
    ;查看raster通用属性
    ncol=rasterf.NCOLUMNS
    nrow=rasterf.NROWS
    print,'numer of columns  number of rows'
    print,ncol,nrow  
  endfor
    
    print,'操作完成。。。。。耗时(分钟):'
    print,(systime(1)-start)/60
    ;e.close
    
end


;--------------------------------------------------------------------------
pro getline,fu,line
  if (not EOF(fu)) then begin   ;EOF function tests to see if file pointer is currently positioned at the end of the file
    alois:
    readf,fu,line
    pos=strpos(line,'#')    ;STRPOS function finds the first occurrence of a substring within a object string (where 0 is the first position of the first character)
    if (pos eq 0) then goto,alois
    line=strtrim(line,1)  ; STRTRIM function removes leading blank from the input string
    line=strcompress(line) ;STRCOMPRESS function returns a copy of String with all whitespace compressed to a single space or completely removed
  endif

  return
end


;--------------------------------------------------------------------------
pro read_CropInfo,dir,DOYie_DL,DOYie_LTDG,Tbase,x1x3
  DOYie_DL=intarr(2)
  DOYie_LTDG=intarr(2)
  Tbase=0.0
  x1x3=intarr(2)
  line=' '
  ; Open crop.doy file for reading
  dirr=dir+'\'
  gfxfile=FILE_SEARCH(dirr+'*.inf')
  openr,95,gfxfile
  ;DOYie_DL
  getline,95,line
  xxx=strsplit(line,/EXTRACT)  ;STRSPLIT function splits an array of string into substrings using keyword EXTRACT
  DOYie_DL=fix(xxx)
  ;DOYie_LTDG
  getline,95,line
  xxx=strsplit(line,/EXTRACT)  ;STRSPLIT function splits an array of string into substrings using keyword EXTRACT
  DOYie_LTDG=fix(xxx)
  ;Tbase
  getline,95,line
  xxx=strsplit(line,/EXTRACT)  ;STRSPLIT function splits an array of string into substrings using keyword EXTRACT
  Tbase=float(xxx)
  ;x1x3
  getline,95,line
  xxx=strsplit(line,/EXTRACT)  ;STRSPLIT function splits an array of string into substrings using keyword EXTRACT
  x1x3=fix(xxx)  
  
  close,95
end


;///////////////////////////////////////////////////////////////////
; Program name: grami_idl2,
;
; A program to simulate LAI and AGDM of using
; a radiation use efficiency concept
; Input files: (1) crop information, (2) weather data, and
; (3) observed crop growth data (LAI or VIs)
;///////////////////////////////////////////////////////////////////

; --- Sub-procedure to read crop information & input files ---
; cType = crop type: 1 = sorghum, 2 = rice, 3 = cotton
; pDOY = DOY at planting/transplanting
; fclimate = climate data file; fcropGrowth = crop growth data file
; irsOBS = input options of RS observations 1-6: 1 = LAI, 2 = NDVI,
;            3 = EVI, 4 = RDVI, 5 = OSAVI, 6 = MTVI
; oSOut = option for outputs of the simulation:
;          0 = no output; 1 = text file only; 2 = text and graph

; --- Sub-procedure to read weather file ---
pro read_weather, DOYarray_meteor, SRarray_meteor, Tairarray_meteor, wData

  ONo=n_elements(DOYarray_meteor)
  ; Define record structure, and create data array
  record={doy:0, sRad:0.0, Tair:0.0, Rain:0.0}
  wData=replicate(record, ONo)
  ;
  for i=0, ONo-1 do begin
    wData[i].doy=DOYarray_meteor[i]
    wData[i].sRad=SRarray_meteor[i]
    wData[i].Tair=Tairarray_meteor[i]
    wData[i].Rain=0.0
  endfor

end ; end sub-pro read_weather


; --- Sub-procedure to read crop growth file ---
pro read_cGrowth, DOY_EVIarray, fData, ONo

  ;DOY=[12,23,45,60,120,165]
  ;EVI=[0.1,0.12,0.2,0.3,0.4,0.15]
  nDOY=DOY_EVIarray[*,0]
  ONo=n_elements(nDOY)
  ; Define record structure, and create data array
  record={doy:0, obs:0.0}
  fData=replicate(record,ONo)
  ;
  for i=0,ONo-1 do begin
    fData[i].doy=DOY_EVIarray[i,0]
    fData[i].obs=DOY_EVIarray[i,1]
  endfor

end ; end sub-pro read_cGrowth


;--- A sub-procudure to designate the ininial parameters for each crop --------
; cType = crop type: 1 = sorghum, 2 = rice, 3 = cotton
; tBase =  base temperature; k = Light extinction coefficient
; RUE = radiation use efficiency; SLA = specific leaf area
; d = leaf senescence parameter; L0 = initial leaf area index
; eGDD = emergence GDD; fGDD = flowering GDD; mGDD = maturity GDD
; hGDD = harvest GDD; IRSOBS = input of RS observations read
; viCon =  conversion factor between VIs and LAI; HI = havest index
pro cParameters, tBase, k, RUE, SLA, d, L0, eGDD, fGDD, mGDD, hGDD, irsOBS, VICon1, VICon2, HI
  tBase = 8.0
  k = 0.5  ; default
  RUE = 3.5  ; default
  SLA = 0.024  ; default
  L0 = 0.002  ; default
  if (irsOBS gt 1) then L0 = 0.002  ; default
  EGDD = 0        ; transplanting
  FGDD = 900
  MGDD = FGDD + 200
  HGDD = MGDD + 60
  d = 10.0
  if (irsOBS gt 1) then d = 8.0 ; d值决定了成熟-收割时期VI下降幅度：d越小，VI下降幅度越快，但是计算的AGB越小，低估产量。一个可能原因是冠层绿叶降低时，生物量贴别是
  ; 籽粒增加，得益于营养生长期储存在茎秆的碳水化合物转移到籽粒，所以即使LAI快速降低，产量也不会有所损失。
  HI = 0.4  ; default
  ;--------------------------------------------------------------
  ; Relationships between LAI and VIs (Rice at CNU 2011-2012)
  ; 2. NDVI = 0.60*LAI^0.35
  ; 3. EVI = 0.39*LAI^0.51
  ; 4. RDVI = 0.36*LAI^0.45
  ; 5. OSAVI = 0.46*LAI^0.39
  ; 6. MTVI = 0.33*LAI^0.56
  ;--------------------------------------------------------------
  if (irsOBS eq 1 or irsOBS eq 2) then begin
    viCon1 = 0.60
    viCon2 = 0.35
  endif else if (irsOBS eq 3) then begin
    viCon1 = 0.39   ;39
    viCon2 = 0.51
  endif else if (irsOBS eq 4) then begin
    viCon1 = 0.36
    viCon2 = 0.45
  endif else if (irsOBS eq 5) then begin
    viCon1 = 0.46
    viCon2 = 0.39
  endif else if (irsOBS eq 6) then begin
    viCon1 = 0.33
    viCon2 = 0.56
  endif ; end rice parameters

end


; --- Sub-procedure for the daily activity of crop growth ---
; wData = weather data, numD = number of the weather data lines
; Kc = light extinction coefficient, LAI = leaf area index, VIs = vegetation indices or ground cover
; viCon = conversion factor between LAI and vegetation indices
; dM = daily increase in above ground dry mass, RUE = radiation use efficiency
; PF = partitioning function, a-b-c-d = leaf partitioning and senescence parameters
; GDD = growing degree days, eGDD = GDD at emerge/resume, SLA = specific leaf area
pro crop_simul, wData, numD, Kc, LAI, VIs, viCon1, viCon2, dM, RUE, AGDM, PF, a,b,c,d, GDD, eGDD, SLA
  RAR = 1.0-exp(-Kc*LAI) ; Radiation absorption ratio based on the modified Beer's law
  APAR = wData[numD-1].sRad * 0.45 * RAR
  dM = RUE * APAR  ; Biomass conversion based on the Monteith's law
  PF = 1.0 - a*exp(b*(GDD-eGDD)) ; Leaf partitioning function
  if PF lt 1.0 then begin
    dLAI = SLA * PF * dM
  endif else dLAI = 0.0
  ; Leaf senescence function
  senf = c*(AGDM/d)
  if (PF le 0.0) then begin
    dLAI = dLAI * senf
  endif
  LAI = LAI + dLAI
  if LAI lt 0.0 then begin
    LAI = 0.0
    senLAI = 0.0
  endif
  AGDM = AGDM + dM

  ; Relation between LAI and VIs
  VIs = viCon1 * LAI ^ viCon2
  if (VIs gt 1.0) then  VIs = 1.0

  ; print, 'In simulation ... WAIT!'
  ; print, wData[numD-1].sRad, APAR, PF, dLAI, dM, LAI, AGDM, format='(7f10.3)'
end ; end sub-pro crop_simul

;--- A sub-procudure to show the simulated and observed results on the screen,
;     and to output the simulated results in the file.
; pa-pb-pc = parameters a, b, c; iLAI = initial LAI
; irsOBS = input options of RS observations 0-6: 0 = no obs, 1 = LAI, 2 = NDVI,
; 3 = EVI, 4 = RDVI, 5 = OSAVI, 6 = MTVI
; oSOut: 0 = no output; 1 = text file only; 2 = text and graph
pro sim_out, workDir, sOut, pa, pb, pc, iLAI, yield, count, irsOBS, oSOut

  file_w = strcompress(workDir+'grami_idl2.out', /remove_all) ; simulated output file
  openw, lun, file_w, /get_lun

  sYield1 = yield * 10      ; Conversion to kg/ha
  sYield2 = yield * 0.92    ; Conversion to lbs/acre

  printf, lun, 'The paramer values used or converged in the simulated result:'
  printf, lun, iLAI, format='(" Inital LAI  = ", f10.5)'
  printf, lun, pa, format='(" Parameter a = ", f10.5)'
  printf, lun, pb, format='(" Parameter b = ", f10.5)'
  printf, lun, pc, format='(" Paramater c = ", f10.5)'
  printf, lun, ' '
  printf, lun, 'Estimated grain yield (kg/ha):'
  printf, lun, SYield1
  printf, lun, ' '
  printf, lun, 'DOY   DAE    GDD       LAI      VIs     AGDM      obs'
  for i = 0, count-1 do begin
    printf, lun, sOut[i,0],sOut[i,1],sOut[i,2],sOut[i,3],sOut[i,4],sOut[i,5], $
      sOut[i,7], format='(i3, i5, 5f9.3)'
  endfor

  if (oSOut ge 2) then begin
    !p.multi = [0,1,2,0,0] ; Set to position multiple plots
    if (irsOBS eq 1) then begin
      plot, sOut[*,1], sOut[*,7], psym = 1, $
        title = 'Simulated & observed LAI/VI', xtitle='Days after planting', ytitle='LAI (m2/m2)'
      oplot, sOut[*,1], sOut[*,3], psym=3
    endif else if (irsOBS ge 2) then begin
      plot, sOut[*,1], sOut[*,7], psym = 1, $
        title = 'Simulated & observed VI', xtitle='Days after planting', ytitle='Vegetation index'
      oplot, sOut[*,1], sOut[*,4], psym=3
    endif
    plot, sOut[*,1], sOut[*,5], psym = 3, $
      title = 'Simulated AGDM', xtitle='Days after planting', ytitle='AGDM (g/m2)'
    ; oplot, sOut[*,1], sOut[*,8], psym=6
  endif
  free_lun, lun
end ; sim_out procedure

;--Calculate mean and 95% Confidence interval of each row of the data_mixing array
pro StatCal, data_mixing, SOut, nnum, EVI_DL, data_processing
  data_processing[0,*] = SOut[*,0] ; DOY
  data_processing[1,*] = SOut[*,1] ; DAE
  data_processing[2,*] = SOut[*,2] ; GDD
  print,nnum
  if (nnum ge 2) then begin
    data_processing[3,*] = MEAN(data_mixing, dimension=1)  ; mean of each row   ; LTDG-dEVI
    data_processing[6,*] = (data_processing[3,*]+EVI_DL*1000)/1000     ;  DL-dEVI
    data_processing[7,*] = (data_processing[3,*]*1000+EVI_DL)/1000       ; LTDG-dEVI
    data_processing[3,*] = (data_processing[3,*]+EVI_DL)/2.0          ; LTDG_DL-dEVI
    data_processing[4,*] = MEAN(data_mixing, dimension=1) - 1.96*STDDEV(data_mixing, dimension=1)/sqrt(nnum)   ;Lower limit of 95% CI
    data_processing[5,*] = MEAN(data_mixing, dimension=1) + 1.96*STDDEV(data_mixing, dimension=1)/sqrt(nnum)   ; upper limit of 95%CI
  endif
  if (nnum eq 1) then begin
    data_processing[3,*] = data_mixing[0,*]  
    data_processing[6,*] = (data_processing[3,*]+EVI_DL*1000)/1000      ; DL_dEVI
    data_processing[7,*] = (data_processing[3,*]*1000+EVI_DL)/1000      ; LTDG_dEVI
    data_processing[3,*] = (data_processing[3,*]+EVI_DL)/2.0        ; LTDG_DL-dEVI
    data_processing[4,*] = 0.0   ;Lower limit of 95% CI
    data_processing[5,*] = 0.0   ; upper limit of 95%CI
  endif

end

; --- Sub-procedure for Erorr confirmation ---
; fData = field observed data, mOut = measured/modified output data
; EF = error function, EP = sum of the positive errors, EN = sum of the negative errors
; no = number of the simulation days, i-j-k-m = subscripts of the arrays used
; ONo = number of the observed LAIs, OLAI = sum of the observed LAI
pro errorF, fData, mOut, EF, EP, EN, no, i, j, k, m, ONo, OLAI
  SumEP=0.0
  SumEN=0.0
  for ii = 0, no-2 do begin
    for jj = 0, ONo-1 do begin
      if (mOut[ii, 0] eq fData[jj].doy) then begin
        mOut[ii, 2] = fData[jj].obs
      endif
    endfor
  endfor

  for ii = 0, no-2 do begin
    if (mOut[ii, 2] gt 0) then begin
      E = mOut[ii, 2] - mOut[ii, 1]
      if E gt 0 then begin
        SumEP = SumEP + E
      endif else if E lt 0 then begin
        SumEN = SumEN - E
      endif
    endif
    OLAI = OLAI + mOut[ii, 2]
  endfor

  EP[i,j,k,m] = SumEP
  EN[i,j,k,m] = SumEN
  EF[i,j,k,m] = SumEP-SumEN
  ; print, 'In errorF, EF =', EF[i,j,k,m], '  EP = ', EP[i,j,k,m], '  EN =', EN[i,j,k,m]
end ; end sub-pro errorF

; --- Sub-procedure for Secant method
; EF = error function, i-j-k-m = subscripts of the arrays used
; iLAI = initial LAI in an array, L0 = intial LAI
; OLAI = sum of the observed LAIs
pro secant, EF, iLAI, i, j, k, m, L0, OLAI
  if (m eq 0) then begin
    if EF[i,j,k,m] gt 0.0 then begin
      L0 = iLAI[i,j,k,m] * (1 + EF[i,j,k,m] / OLAI)
    endif else if (EF[i,j,k,m] lt 0.0) then begin
      L0 = iLAI[i,j,k,m] / (1 - EF[i,j,k,m] / OLAI)
    endif
  endif else if (m ge 1) then begin
    LCal = iLAI[i,j,k,m] - iLAI[i,j,k,m-1]
    ECal = EF[i,j,k,m] - EF[i,j,k,m-1]
    if (LCal eq 0.0 OR ECal eq 0.0) then begin
      L0 = iLAI[i,j,k,m]
    endif else begin
      ; The secant method (Conte & De Boor, 1965)
      EQuat = LCal/ECal
      L0 = iLAI[i,j,k,m] + EF[i,j,k,m] * EQuat
    endelse
    L0 = ABS(L0)
  endif
  ; print, 'In secant pro, L0=', L0
end

; --- sub-procedure for 'C' braketing search ---
; paraC and EFL = arrays holding the parameter 'C' and error function of inital LAIs
; i-j-k = subscripts of the arrays used, C = parameter 'C' value
pro braketC, paraC, EFL, i, j, k, C
  if (k eq 0) then C = paraC[i,j,k] + 0.0005
  if (k eq 1 and paraC[i,j,1] eq (paraC[i,j,0] + 0.0005)) then begin
    if EFL[k-1] gt EFL[k] then begin
      k = 0
      C = paraC[i,j,k] - 0.0005
    endif else begin
      C = paraC[i,j,k] + 0.0005
    endelse
  endif
  if (k eq 1 and paraC[i,j,1] eq (paraC[i,j,0] - 0.0005)) then begin
    C = paraC[i,j,k] - 0.0005
  endif
  ; print, 'In braketC pro, C=', C
end

; --- sub-procedure for 'B' braketing search ---
; paraB and EFC = arrays holding parameter 'B' and error function of 'C' values
; i-j = subscripts of the arrays used, B = parameter 'B' value
pro braketB, paraB, EFC, i, j, B
  if j eq 0 THEN B = paraB[i,j] + 0.0005
  if (j eq 1 AND paraB[i,1] eq (paraB[i,0] + 0.0005)) THEN begin
    if EFC[j-1] gt EFC[j] then begin
      j = 0
      B = paraB[i,j] - 0.0005
    endif ELSE begin
      B = paraB[i,j] + 0.0005
    endelse
  endif
  if (j eq 1 AND paraB[i,1] eq (paraB[i,0] - 0.0005)) THEN begin
    B = paraB[i,j] - 0.0005
  endif
  ; print, 'In braketB pro, B=', B
end

; --- sub-procedure for 'A' braketing search ---
; paraA = array holding parameters 'A', EFB = error function of parameter 'B'
; i = subscript of the array used, A = parameter 'A'
pro braketA, paraA, EFB, i, A
  if i eq 0 THEN A = paraA[i] + 0.005
  if (i eq 1 AND paraA[1] eq (paraA[0] + 0.005)) THEN begin
    IF EFB[i-1] gt EFB[i] THEN begin
      i = 0
      A = paraA[i] - 0.005
    endif else begin
      A = paraA[i] + 0.005
    endelse
  endif
  if (i eq 1 AND paraA[1] eq (paraA[0] - 0.005)) THEN begin
    B = paraA[i] - 0.005
  endif
  ; print, 'In braketA pro, A=', A
end

; --- Sub-procedure to find out the minimum error value after the m Loop ---
; EF = error function, iLAI = initial LAI, EFL = error function of the initial LAI,
; itr = no of iteration, i-j-k-m = subscripts of the arrays used, L0 = initial LAI
pro min_iLAI, EF, iLAI, EFL, itr, i, j, k, m, L0
  nMin = 99999999
  tempL = 0.0 ; tempL = temporal initial LAI
  for mm = 0, itr-1 do begin
    EF[i,j,k,mm] = ABS(EF[i,j,k,mm])
    if EF[i,j,k,mm] gt 0.0 then begin
      if EF[i,j,k,mm] lt nMin then begin
        nMin = EF[i,j,k,mm]
        tempL = iLAI[i,j,k,mm]
      endif
    endif
  endfor
  EFL[m] = nMin
  L0 = tempL
  ; print, 'In min_iLAI pro, L0=', L0
end

; --- Sub-procedure to find out the minimum error value after the k Loop ---
; EF = error function, paraC = array holding the parameter 'C',
; EFC = error fuction of parameter 'C', itr = no of iteration,
; i-j-k-m = subscripts of the arrays used, C = parameter 'C'
pro minC, EF, paraC, EFC, itr, i, j, k, m, C
  nMin = 99999999
  tempC = 0.0 ; tempC = temporal parameter C
  for kk = 0, itr-1 do begin
    EF[i,j,kk,m-1] = ABS(EF[i,j,kk,m-1])
    IF EF[i,j,kk,m-1] gt 0.0 then begin
      IF EF[i,j,kk,m-1] lt nMin then begin
        nMin = EF[i,j,kk,m-1]
        tempC = paraC[i,j,kk]
      endif
    endif
  endfor
  EFC[k] = nMin
  C = tempC
  ; print, 'In minC pro, C=', C
end

; --- Sub-procedure to find out the minimum error value after the j Loop ---
; EF = error fucntion, paraB = array holding parameter 'B',
; EFA = error function of parameter 'A', itr = no of iteration,
; i-j-k-m = subscripts of the arrays used, ; A = parameter A
pro minB, EF, paraB, EFB, itr, i, j, k, m, B
  nMin = 99999999
  tempB = 0.0 ; temporal paramater B
  for jj = 0, itr-1 do begin
    EF[i,jj,k-1,m-1] = ABS(EF[i,jj,k-1,m-1])
    if EF[i,jj,k-1,m-1] gt 0.0 then begin
      if EF[i,jj,k-1,m-1] lt nMin then begin
        nMin = EF[i,jj,k-1,m-1]
        tempB = paraB[i,jj]
      endif
    endif
  endfor
  EFB[j] = nMin
  B = tempB
  ; print, 'In minA pro, A=', A
end

; --- Sub-procedure to find out the minimum error value after the i Loop ---
; EF = error fucntion, paraB = array holding parameter 'B',
; EFB = error function of parameter 'B', itr = no of iteration,
; i-j-k-m = subscripts of the arrays used, ; B = parameter B
pro minA, EF, paraA, EFA, itr, i, j, k, m, A
  nMin = 99999999
  tempA = 0.0 ; temporal paramater A
  for ii = 0, itr-1 do begin
    EF[ii,j-1,k-1,m-1] = ABS(EF[ii,j-1,k-1,m-1])
    if EF[ii,j-1,k-1,m-1] gt 0.0 then begin
      if EF[ii,j-1,k-1,m-1] lt nMin then begin
        nMin = EF[ii,j-1,k-1,m-1]
        tempA = paraA[ii]
      endif
    endif
  endfor
  EFA[i] = nMin
  A = tempA
  ; print, 'In minA pro, A=', A
end

; --- Sub-procedure to find out the minimum error value and the intial L and
; --- the parameters(a,b,c) after the final loop
; itr = no of iteration, i-j-k-m = subscripts of the arrays used,
; A-B-C = parameters A,  B, and C, L0 = initial LAI
pro minimum, EF, EP, EN, paraA, paraB, paraC, iLAI, itr, i, j, k, m, B, A, C, L0
  nMin = 99999999
  tempA = 0.0
  tempB = 0.0
  tempC = 0.0
  tempL = 0.0
  for i = 0, itr-1 do begin
    for j = 0, itr-1 do begin
      for k = 0, itr-1 do begin
        for m = 0, itr-1 do begin
          EN[i,j,k,m] = ABS(EN[i,j,k,m])
          EF[i,j,K,m] = ABS(EF[i,j,k,m])
          if (EF[i,j,k,m] gt 0.0 and EP[i,j,k,m] gt 0.0 and EN[i,j,k,m] gt 0.0) then begin
            if (EF[i,j,k,m] + EP[i,j,k,m] + EN[i,j,k,m] lt nMin) then begin
              nMin = EF[i,j,k,m] + EP[i,j,k,m] + EN[i,j,k,m]
              minEF = EF[i,j,k,m]
              minEP = EP[i,j,k,m]
              minEN = EN[i,j,k,m]
              tempA = paraA[i]
              tempB = paraB[i,j]
              tempC = paraC[i,j,m]
              tempL = iLAI[i,j,k,m]
            endif
          endif
        endfor ; end for 'm'
      endfor ; end for 'k'
    endfor ; end for 'j'
  endfor ; end for 'i'
  A = tempA
  B = tempB
  C = tempC
  L0 = tempL
  ; print, 'Parameter values after the minimum sub-procudure'
  ; print, 'Minimum Ef', minEF, '  L0=', L0, '  A=', A, ' B=', B, '  C=', C
end ; end sub-pro minimum

; --- sub-procedure for the bracketing search and parablic interpolation procedure
; --- to find out a minimum 'A' parameter.
pro para_A, paraA, EF, i, j, k, m, A
  X = (paraA[i-1]-paraA[i-2])^2*(EF[i-1,j,k,m]-EF[i,j,k,m])
  Y = (paraA[i-1]-paraA[i-2])*(EF[i-1,j,k,m]-EF[i,j,k,m])
  V = (paraA[i-1]-paraA[i])^2*(EF[i-1,j,k,m]-EF[i-2,j,k,m])
  W = (paraA[i-1]-paraA[i])*(EF[i-1,j,k,m]-EF[i-2,j,k,m])
  if (X-V eq 0.0 OR Y-W eq 0.0) then begin
    A = paraA[i-1] + 0.5
  endif else begin
    A = paraA[i-1] + 0.5 * ((X-V)/(Y-W))
  endelse
  ; print, 'In para_A pro, A=', A
end

; --- sub-procedure for the bracketing search and parablic interpolation procedure
; --- to find out a minimum 'B' parameter.
pro para_B, paraB, EF, i, j, k, m, B
  X = (paraB[i,j-1]-paraB[i,j-2])^2*(EF[i,j-1,k,m]-EF[i,j,k,m])
  Y = (paraB[i,j-1]-paraB[i,j-2])*(EF[i,j-1,k,m]-EF[i,j,k,m])
  V = (paraB[i,j-1]-paraB[i,j])^2*(EF[i,j-1,k,m]-EF[i,j-2,k,m])
  W = (paraB[i,j-1]-paraB[i,j])*(EF[i,j-1,k,m]-EF[i,j-2,k,m])
  if (X-V eq 0.0 OR Y-W eq 0.0) then begin
    B = paraB[i,j-1] + 0.5
  endif else begin
    B = paraB[i,j-1] + 0.5 * ((X-V)/(Y-W))
  endelse
  ; print, 'In para_B pro, B=', B
end

; --- Sub-procedure for the bracketing search and parablic interpolation procedure
; --- to find out a minimum c parameter.
; paraC = arrary holding the parameter 'C', EF = array holding the error function
; i-j-k-m = subsripts of the array used, C = parameter 'C'
pro para_C, paraC, EF, i, j, k, m, C
  X = (paraC[i,j,k-1]-paraC[i,j,k-2])^2*(EF[i,j,k-1,m]-EF[i,j,k,m])
  Y = (paraC[i,j,k-1]-paraC[i,j,k-2])*(EF[i,j,k-1,m]-EF[i,j,k,m])
  V = (paraC[i,j,k-1]-paraC[i,j,k])^2*(EF[i,j,k-1,m]-EF[i,j,k-2,m])
  W = (paraC[i,j,k-1]-paraC[i,j,k])*(EF[i,j,k-1,m]-EF[i,j,k-2,m])
  if (X-V eq 0.0 OR Y-W eq 0.0) then begin
    C = paraC[i,j,k-1] + 0.5
  endif else begin
    C = paraC[i,j,k-1] + 0.5 * ((X-V)/(Y-W))
  endelse
  ; print, 'In para_C pro, C=', C
end


; --- sub-procedure for double logistic fcuntion
function myfunct,xx,pp    ; The user must define a function which returns the model value; Parameter values are passed in "p"
  ymod=1./(1.+exp((pp[0]-xx)/pp[1]))-1./(1.+exp((pp[2]-xx)/pp[3]))  ; The model computes Y given X
  return,ymod
end


; ------------------------------------------------------------------------------------------------------------
pro Random_sampling_without_replication,EVIts_LTDG,DOYts_LTDG,DOYEVIarray_list_LTDG
  
  ;初始化随机取样表单
  DOYEVIarray_list_LTDG=list()
  
  ; 查验  EVIts_LTDG数组各有多少个元素
  ; 如果EVIts_LTDG只含有1-3个元素，不参与随机取样
  if (n_elements(EVIts_LTDG) le 3) then begin
    DOY_EVI=[[DOYts_LTDG],[EVIts_LTDG]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
  endif
  if (n_elements(EVIts_LTDG) eq 4) then begin
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[1],DOYts_LTDG[2]],[EVIts_LTDG[0],EVIts_LTDG[1],EVIts_LTDG[2]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[1],DOYts_LTDG[3]],[EVIts_LTDG[0],EVIts_LTDG[1],EVIts_LTDG[3]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[2],DOYts_LTDG[3]],[EVIts_LTDG[0],EVIts_LTDG[2],EVIts_LTDG[3]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[1],DOYts_LTDG[2],DOYts_LTDG[3]],[EVIts_LTDG[1],EVIts_LTDG[2],EVIts_LTDG[3]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG],[EVIts_LTDG]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
  endif
  if (n_elements(EVIts_LTDG) eq 5) then begin
    DOY_EVI=[[DOYts_LTDG[1],DOYts_LTDG[3],DOYts_LTDG[4]],[EVIts_LTDG[1],EVIts_LTDG[3],EVIts_LTDG[4]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[2],DOYts_LTDG[3],DOYts_LTDG[4]],[EVIts_LTDG[2],EVIts_LTDG[3],EVIts_LTDG[4]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[1],DOYts_LTDG[2],DOYts_LTDG[3]],[EVIts_LTDG[0],EVIts_LTDG[1],EVIts_LTDG[2],EVIts_LTDG[3]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[1],DOYts_LTDG[2],DOYts_LTDG[4]],[EVIts_LTDG[0],EVIts_LTDG[1],EVIts_LTDG[2],EVIts_LTDG[4]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[1],DOYts_LTDG[3],DOYts_LTDG[4]],[EVIts_LTDG[0],EVIts_LTDG[1],EVIts_LTDG[3],EVIts_LTDG[4]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[2],DOYts_LTDG[3],DOYts_LTDG[4]],[EVIts_LTDG[0],EVIts_LTDG[2],EVIts_LTDG[3],EVIts_LTDG[4]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[1],DOYts_LTDG[2],DOYts_LTDG[3],DOYts_LTDG[4]],[EVIts_LTDG[1],EVIts_LTDG[2],EVIts_LTDG[3],EVIts_LTDG[4]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG],[EVIts_LTDG]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
  endif
  if (n_elements(EVIts_LTDG) eq 6) then begin
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[1],DOYts_LTDG[2],DOYts_LTDG[4]],[EVIts_LTDG[0],EVIts_LTDG[1],EVIts_LTDG[2],EVIts_LTDG[4]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[1],DOYts_LTDG[2],DOYts_LTDG[5]],[EVIts_LTDG[0],EVIts_LTDG[1],EVIts_LTDG[2],EVIts_LTDG[5]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[1],DOYts_LTDG[3],DOYts_LTDG[4]],[EVIts_LTDG[0],EVIts_LTDG[1],EVIts_LTDG[3],EVIts_LTDG[4]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[2],DOYts_LTDG[3],DOYts_LTDG[4]],[EVIts_LTDG[0],EVIts_LTDG[2],EVIts_LTDG[3],EVIts_LTDG[4]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[2],DOYts_LTDG[3],DOYts_LTDG[5]],[EVIts_LTDG[0],EVIts_LTDG[2],EVIts_LTDG[3],EVIts_LTDG[5]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[3],DOYts_LTDG[4],DOYts_LTDG[5]],[EVIts_LTDG[0],EVIts_LTDG[3],EVIts_LTDG[4],EVIts_LTDG[5]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[1],DOYts_LTDG[2],DOYts_LTDG[3],DOYts_LTDG[4]],[EVIts_LTDG[1],EVIts_LTDG[2],EVIts_LTDG[3],EVIts_LTDG[4]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[1],DOYts_LTDG[2],DOYts_LTDG[3],DOYts_LTDG[5]],[EVIts_LTDG[1],EVIts_LTDG[2],EVIts_LTDG[3],EVIts_LTDG[5]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[1],DOYts_LTDG[3],DOYts_LTDG[4],DOYts_LTDG[5]],[EVIts_LTDG[1],EVIts_LTDG[3],EVIts_LTDG[4],EVIts_LTDG[5]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[2],DOYts_LTDG[3],DOYts_LTDG[4],DOYts_LTDG[5]],[EVIts_LTDG[2],EVIts_LTDG[3],EVIts_LTDG[4],EVIts_LTDG[5]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[1],DOYts_LTDG[2],DOYts_LTDG[3],DOYts_LTDG[4]],[EVIts_LTDG[0],EVIts_LTDG[1],EVIts_LTDG[2],EVIts_LTDG[3],EVIts_LTDG[4]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[1],DOYts_LTDG[2],DOYts_LTDG[3],DOYts_LTDG[5]],[EVIts_LTDG[0],EVIts_LTDG[1],EVIts_LTDG[2],EVIts_LTDG[3],EVIts_LTDG[5]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[1],DOYts_LTDG[2],DOYts_LTDG[4],DOYts_LTDG[5]],[EVIts_LTDG[0],EVIts_LTDG[1],EVIts_LTDG[2],EVIts_LTDG[4],EVIts_LTDG[5]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[2],DOYts_LTDG[3],DOYts_LTDG[4],DOYts_LTDG[5]],[EVIts_LTDG[0],EVIts_LTDG[2],EVIts_LTDG[3],EVIts_LTDG[4],EVIts_LTDG[5]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[1],DOYts_LTDG[2],DOYts_LTDG[3],DOYts_LTDG[4],DOYts_LTDG[5]],[EVIts_LTDG[1],EVIts_LTDG[2],EVIts_LTDG[3],EVIts_LTDG[4],EVIts_LTDG[5]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[1],DOYts_LTDG[3],DOYts_LTDG[4],DOYts_LTDG[5]],[EVIts_LTDG[0],EVIts_LTDG[1],EVIts_LTDG[3],EVIts_LTDG[4],EVIts_LTDG[5]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG],[EVIts_LTDG]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
  endif
  if (n_elements(EVIts_LTDG) eq 7) then begin
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[1],DOYts_LTDG[2],DOYts_LTDG[3],DOYts_LTDG[4],DOYts_LTDG[5]],[EVIts_LTDG[0],EVIts_LTDG[1],EVIts_LTDG[2],EVIts_LTDG[3],EVIts_LTDG[4],EVIts_LTDG[5]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[1],DOYts_LTDG[3],DOYts_LTDG[4],DOYts_LTDG[5],DOYts_LTDG[6]],[EVIts_LTDG[0],EVIts_LTDG[1],EVIts_LTDG[3],EVIts_LTDG[4],EVIts_LTDG[5],EVIts_LTDG[6]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[2],DOYts_LTDG[3],DOYts_LTDG[4],DOYts_LTDG[5],DOYts_LTDG[6]],[EVIts_LTDG[0],EVIts_LTDG[2],EVIts_LTDG[3],EVIts_LTDG[4],EVIts_LTDG[5],EVIts_LTDG[6]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[1],DOYts_LTDG[2],DOYts_LTDG[3],DOYts_LTDG[4],DOYts_LTDG[5],DOYts_LTDG[6]],[EVIts_LTDG[1],EVIts_LTDG[2],EVIts_LTDG[3],EVIts_LTDG[4],EVIts_LTDG[5],EVIts_LTDG[6]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[1],DOYts_LTDG[2],DOYts_LTDG[4],DOYts_LTDG[5],DOYts_LTDG[6]],[EVIts_LTDG[0],EVIts_LTDG[1],EVIts_LTDG[3],EVIts_LTDG[4],EVIts_LTDG[5],EVIts_LTDG[6]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[1],DOYts_LTDG[2],DOYts_LTDG[3],DOYts_LTDG[5],DOYts_LTDG[6]],[EVIts_LTDG[0],EVIts_LTDG[1],EVIts_LTDG[2],EVIts_LTDG[3],EVIts_LTDG[5],EVIts_LTDG[6]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG],[EVIts_LTDG]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
  endif
  if (n_elements(EVIts_LTDG) ge 8) then begin
    tot_No=n_elements(EVIts_LTDG)
    mid_No=round(tot_No/2.0)
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[mid_No-2],DOYts_LTDG[mid_No-1],DOYts_LTDG[mid_No],DOYts_LTDG[mid_No+1],DOYts_LTDG[tot_No-1]],[EVIts_LTDG[0],EVIts_LTDG[mid_No-2],EVIts_LTDG[mid_No-1],EVIts_LTDG[mid_No],EVIts_LTDG[mid_No+1],EVIts_LTDG[tot_No-1]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[1],DOYts_LTDG[mid_No-2],DOYts_LTDG[mid_No-1],DOYts_LTDG[mid_No],DOYts_LTDG[mid_No+1],DOYts_LTDG[tot_No-1]],[EVIts_LTDG[1],EVIts_LTDG[mid_No-2],EVIts_LTDG[mid_No-1],EVIts_LTDG[mid_No],EVIts_LTDG[mid_No+1],EVIts_LTDG[tot_No-1]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[1],DOYts_LTDG[mid_No-2],DOYts_LTDG[mid_No-1],DOYts_LTDG[mid_No],DOYts_LTDG[mid_No+1],DOYts_LTDG[tot_No-2]],[EVIts_LTDG[1],EVIts_LTDG[mid_No-2],EVIts_LTDG[mid_No-1],EVIts_LTDG[mid_No],EVIts_LTDG[mid_No+1],EVIts_LTDG[tot_No-2]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG[0],DOYts_LTDG[mid_No-2],DOYts_LTDG[mid_No-1],DOYts_LTDG[mid_No],DOYts_LTDG[mid_No+1],DOYts_LTDG[tot_No-2]],[EVIts_LTDG[0],EVIts_LTDG[mid_No-2],EVIts_LTDG[mid_No-1],EVIts_LTDG[mid_No],EVIts_LTDG[mid_No+1],EVIts_LTDG[tot_No-2]]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
    DOY_EVI=[[DOYts_LTDG],[EVIts_LTDG]]
    DOYEVIarray_list_LTDG.add,DOY_EVI
  endif
end


;--------------------------------------------------------------------------
pro Pheno_accGDDs, GSaccGDDs, FGDDs_year, MGDDs_year, HGDDs_year
  ;FGDDs_year=[750,800,850,900,950,1000]  ; for 2009  当前需要手动配置 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!2010; [750,800,850,900,950,1000]
  ;MGDDs_year=[400,400,400,350,350,300]                                                                                       ; [450,450,400,350,350,300]
  ;HGDDs_year=[250,250,250,250,250,250]                                                                                       ; [250,250,250,250,250,250]
  FGDDs_year=[]
  MGDDs_year=[]
  HGDDs_year=[]
  for i=600.0,1500.0,100.0 do begin
    stage1=i
    stage3=120.0
    stage2=GSaccGDDs-stage1-stage3-10.0
    if (stage2 ge 200.0) then begin
      FGDDs_year=[FGDDs_year,stage1]
      MGDDs_year=[MGDDs_year,stage2]
      HGDDs_year=[HGDDs_year,stage3]
    endif
  endfor
end


;**--------------------------------------------------------------------------------------------------------------
; *** Main procedure of the LTDG_DL_Algorithm that predict EVI dailt data
;*********************************************************************
pro LTDG_DL_Algorithm,GSaccGDDs,DOYts_LTDG,EVIts_LTDG,DOYts_DL,EVIts_DL,$
                           DOYarray_meteor,SRarray_meteor,Tairarray_meteor,DOYini_LTDG,DOYend_LTDG,Tbase,iii,jjj,x1x3,dir,counter_N
  
  workDir=dir+'\Results\'  ; your working directory
  dir_test=file_test(workDir,/directory)
  if dir_test eq 0 then file_mkdir,workDir
  
  ;计算 FGDDs_year, MGDDs_year, HGDDs_year
  Pheno_accGDDs,GSaccGDDs,FGDDs_year,MGDDs_year,HGDDs_year
  print,'FGDDs_year is:',FGDDs_year
  print,'MGDDs_year is:',MGDDs_year
  print,'HGDDs_year is:',HGDDs_year
  
  ;无重复穷尽取样法
  Random_sampling_without_replication,EVIts_LTDG,DOYts_LTDG,DOYEVIarray_list_LTDG

  ; Get crop information data from sub-pro read_CropInfo
  ; cType = crop types 1-7: 1=Sorghum, 2=Rice, 3=Cotton, 4=, 5=, 6=, 7=
  ; pDOY = pre-setted planting day of year
  ; irsOBS = input options of RS observations 0-6: 0 = no obs, 1 = LAI, 2 = NDVI,
  ;    3 = EVI, 4 = RDVI, 5 = OSAVI, 6 = MTVI
  ; oSOut = option for outputs of the simulation:
  ;      0 = no output; 1 = text file only; 2 = text and graph
  ;read_cropInfo, file_r0, cType, pDOY, fclimate, irsOBS, oSOut
  irsOBS=3
  oSOut=1
  pDOY=DOYini_LTDG
  DOYend_LTDG=DOYend_LTDG
  x1x3=x1x3
  No_CropEVIibs=n_elements(EVIts_LTDG)

  ; Get weather data from sub-pro read_weatherR
  ; wData=array holding weather data
  ; nWLines=number of weather data lines
  read_weather, DOYarray_meteor, SRarray_meteor, Tairarray_meteor, wData
  nWLines=n_elements(DOYarray_meteor)
  aDate=pDOY - DOYarray_meteor[0] ; Accumulated date from initial weather to planting

  ;逐一像元重建EVI时序Reconstruct daily EVI in each crop pixel
  ;(1)DL函数重建EVI时序
  xx=DOYts_DL
  yy=EVIts_DL
  num=n_elements(yy)
  ;define a vector of measurement error
  parinfo=replicate({value:0.D,fixd:0,limited:[0,0],limits:[0.D,0]},4)
  parinfo[*].value=[pDOY+25,16.1,x1x3[1]+25,16.1]
  parinfo[0].limited[0]=1 ;set lower limit for the p[0]-onset
  parinfo[0].limits[0]=pDOY
  parinfo[0].limited[1]=1 ;set upper limit for the p[0]-onset
  parinfo[0].limits[1]=x1x3[0]
  parinfo[2].limited[0]=1 ;set lower limit for the p[2]-end
  parinfo[2].limits[0]=x1x3[1]
  parinfo[2].limited[1]=1 ;set upper limit for the p[2]-end
  parinfo[2].limits[1]=DOYend_LTDG
  parinfo[1].limited[0]=1 ;set lower limit for the p[1]-change rate of left-hand side
  parinfo[1].limits[0]=8.8
  parinfo[1].limited[1]=1 ;set upper limit for the p[1]-change rate of left-hand side
  parinfo[1].limits[1]=40.9
  parinfo[3].limited[0]=1 ;set lower limit for the p[3]-change rate of right-hand side
  parinfo[3].limits[0]=8.8
  parinfo[3].limited[1]=1 ;set upper limit for the p[3]-change rate of right-hand side
  parinfo[3].limits[1]=40.9
  ;pstart=[160.D,16.1,270.,16.1]
  err=replicate(0.01,num)
  parms=mpfitfun('myfunct',xx,yy,err,parinfo=parinfo,NAN)
  print,parms

  ;(2)根据DOYini至年末accGDDs来分配FGDDs,MGDDs and HGDDs；FGDDS+mGDDs+HGDDs不能超过生长季有效accGDDs
  ;设置一系列FGDDs,;运行LTDG算法重建EVI时序,构建LEVIreference database
  ;FGDDs_year=[750,800,850,900,950,1000]  ; for 2009  当前需要手动配置 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!2010; [750,800,850,900,950,1000]
  ;MGDDs_year=[400,400,400,350,350,300]                                                                                       ; [450,450,400,350,350,300]
  ;HGDDs_year=[250,250,250,250,250,250]                                                                                       ; [250,250,250,250,250,250]

  ;创建表单来保存FGDDs运算产生的dEVI时间序列
  LEVIreference=list()
  RMSE_array=[]
  for ith=0,N_Elements(FGDDs_year)-1 do begin
    ithFGDDs=FGDDs_year[ith]
    ithMGDDs=ithFGDDs+MGDDs_year[ith]
    ithHGDDs=ithMGDDs+HGDDs_year[ith]
    ;;;LTDG算法重建EVI时序
    nnum=N_Elements(DOYEVIarray_list_LTDG)
    Data_mixing=fltarr(nnum,nWLines)
    data_processing=make_array(8,nWLines)  ; 先列后行DOY, DAP, accGDDs, LTDG_DG-EVI, L95%, U95%, DL-EVI, LTDG-EVI
    ;
    for fNO=0,nnum-1 do begin   ;
      DOY_EVIarray=DOYEVIarray_list_LTDG[fNO]
      ; Get crop growth data from sub-pro read_cGrwoth
      ; fData=array holding observed crop growth data
      ; ONo=observed plant grwoth numbers
      if (irsOBS ne 0) then read_cGrowth, DOY_EVIarray, fdata, ONo
      ; Determine number of iteration depedning on the observation
      if (ONo lt 5) then itr = 5 else itr = 10
      ; Initialize crop growth parameters
      Tb=0.0  ; base temperature
      Kc=0.0  ; light extinction coefficient
      RUE=0.0 ; radiation use efficiency
      SLA=0.0 ; specific leaf area
      L0=0.0 ; initial leaf area index
      emergeGDD=0.0 ; GDD at emergence or resume for transplanting
      flowerGDD=0.0 ; GDD at flower
      matureGDD=0.0 ; GDD at maturity
      harvestGDD=0.0 ; GDD at harvest
      ; Get crop grwoth prameter values from sub-pro CParameters by Calling
      CParameters, Tb, Kc, RUE, SLA, d, L0, emergeGDD, flowerGDD, matureGDD, $
        harvestGDD, IRSOBS, viCon1, viCon2, HI
      flowerGDD=ithFGDDs
      matureGDD=ithMGDDs
      harvestGDD=ithHGDDs
      Tb=Tbase
      ;
      b=0.00125 ; leaf partitioning parameter
      a=exp(-b*flowerGDD) ; leaf partitioning parameter
      c=0.00125 ; leaf senescence parameter
      ; Arrays used:
      ; paraB, paraA, paraC: holding A, B, and C parameters
      ; EFL,EFC,EFA: holding error funtions used in the next parablic interpolation
      ; SOut: holding the simulated output
      itr2=itr*2
      paraA=fltarr(itr2)
      paraB=fltarr(itr2,itr2)
      paraC=fltarr(itr2,itr2,itr2)
      EFL=fltarr(itr2)
      EFA=fltarr(itr2)
      EFB=fltarr(itr2)
      EFC=fltarr(itr2)
      SOut=fltarr(nWLines, itr2)
      dStage=fltarr(4,2)
      iLAI=fltarr(itr2,itr2,itr2,itr2)
      EF=fltarr(itr2,itr2,itr2,itr2)
      EP=fltarr(itr2,itr2,itr2,itr2)
      EN=fltarr(itr2,itr2,itr2,itr2)
      mOut=fltarr(250,3)
      ; openw, lun, file_w1, /get_lun
      ; printf, lun, '  i    j    k    m       C        A         B        L0'
      for i=0,itr-1 do begin
        if (A gt 0.005 and A lt 0.5) then begin
          paraA[i]=A
          A=paraA[i]
          for j=0,itr-1 do begin
            if (B gt 0.0005 and B lt 0.5) then begin
              paraB[i,j]=B
              B=paraB[i,j]
              for k=0,itr-1 do begin
                if (C gt 0.0005 and C lt 0.5) then begin
                  paraC[i,j,k]=C
                  C = paraC[i,j,k]
                  for m=0,itr-1 do begin    ; 优化L0
                    if (L0 lt 0.5) then begin
                      GDD=0.0  ; Growing Degree Days
                      AGDM=0.0  ; Above Ground Dry Mass
                      OLAI=0.0 ; observed LAI
                      n=0  ; count for days after planting
                      numD=aDate   ; accumulated date from starting date to planting
                      iLAI[i,j,k,m]=L0
                      LAI=iLAI[i,j,k,m]
                      ; printf, lun, i, j, k, m, C, A, B, LAI, format='(i3, 3i5, 4f10.5)'
                      while (GDD lt harvestGDD) do begin   ; matureGDD,  harvestGDD
                        GTemp=wData[numD].Tair - Tb
                        if (GTemp lt 0) then GTemp=0
                        GDD=GDD+GTemp  ; --- accumulate the Degree Days
                        if (GDD ge emergeGDD) then begin
                          crop_simul, wData, numD, Kc, LAI, VIs, viCon1, viCon2, dM, RUE, AGDM, PF, $
                            A,B,C,D, GDD, emergeGDD, SLA  ; call simul pro
                          mOut[n,0]=wData[numD].doy
                          if (irsOBS eq 1) then mOut[n,1] = LAI
                          if (irsOBS ge 2) then mOut[n,1] = VIs
                          n=n+1
                        endif
                        numD=numD+1
                      endwhile
                      errorF, fData, mOut, EF, EP, EN, n, i, j, k, m, ONo, OLAI ; call errorF pro
                      Secant, EF, iLAI, i, j, k, m, L0, OLAI ; call secant pro
                    endif else break ; exit for 'm'
                  endfor ; end for 'm'
                  min_iLAI, EF, iLAI, EFL, itr, i, j, k, m, L0 ; call min_iLAI pro
                  braketC, paraC, EFL, i, j, k, C ; call braketC pro
                  if (k ge 2) then $
                    para_C, paraC, EF, i, j, k, m, C ; call paraC pro
                endif else break ; exit for 'k'
              endfor ; end for 'k'
              minC, EF, paraC, EFC, itr, i, j, k, m, C ; call minC pro
              braketB, paraB, EFC, i, j, B ; call braketA pro
              if (j ge 2) then $
                para_B, paraB, EF, i, j, k, m, B ; call paraA pro
            endif else break ; exit for 'j'
          endfor ; end for 'j'
          minB, EF, paraB, EFB, itr, i, j, k, m, B ; call MinA pro
          braketA, paraA, EFB, i, A ; call braketB pro
          if (i ge 2) then $
            para_A, paraA, EF, i, j, k, m, A ; call paraB pro
        endif else break ; exit for 'i'
        minA, EF, paraA, EFA, itr, i, j, k, m, A ; call MinB pro
      endfor ; end for 'i'
      minimum, EF,EP,EN,paraA,paraB,paraC,iLAI,itr,i,j,k,m,B,A,C,L0 ; call Minimum pro
      ; free_lun, lun
      ;print, 'Minimum Ef', minEF, '  L0=', L0, '  A=', A, ' B=', B, '  C=', C
      ; --- Initialization for the variables
      GDD=0.0
      AGDM=0.0
      LAI=L0
      i=0
      numD=fix(aDate)
      ;
      while (GDD lt harvestGDD) do begin
        GTemp=wData[numD].Tair - Tb
        if (GTemp lt 0) then GTemp=0.0
        GDD=GDD+GTemp  ; --- accumulate the Degree Days
        if (GDD lt emergeGDD) then begin
          DStage[0,0]=wData[numD].doy ; --- DOY at emergence
        endif else if (GDD lt flowerGDD) then begin
          DStage[1,0]=wData[numD].doy ; --- DOY at flowering
        endif else if (GDD lt matureGDD) then begin
          DStage[2,0]=wData[NumD].doy ; --- DOY at maturity
        endif
        if (GDD ge emergeGDD) then begin
          ; call 'crop_simul.pro'
          crop_simul, wData, numD, Kc, LAI, VIs, viCon1, viCon2, dM, RUE, AGDM, PF, $
            A,B,C,D, GDD, emergeGDD, SLA  ; call simul pro
          SOut[i,0]=wData[numD].doy
          SOut[i,1]=i
          SOut[i,2]=GDD
          SOut[i,3]=LAI
          SOut[i,4]=VIs
          SOut[i,5]=AGDM
          SOut[i,6]=PF
          for j=0, ONo-1 do begin
            if SOut[i,0] eq fData[j].doy then begin
              SOut[i,7]=fData[j].obs
            endif
          endfor
          i=i+1
        endif
        numD=numD+1
      endwhile

      yield=sOut[i-1,5] * HI
      count=i

      data_mixing[fNO,*]=SOut[*,4]

      ; call 'sim_out subroutine'
      if (oSOut ne 0) then sim_out, workDir, SOut, A, B, C, L0, yield, count, irsOBS, oSOut
      print, strcompress(string(fNO+1)+'th_'+'Simulation Completed!', /remove_all)
      close, /all
    endfor

    ;需要根据LTDG重建EVI时序计算对应时间段的DL-EVI时序[aDate, numD]
    LGP=numD-fix(aDate+1)+1
    ;print,'Start date is',fix(aDate+1)
    ;print,'End data is',numD
    print,'The length of growth period is: ',LGP
    print,'The starting date of seedling growth is: ',fix(pDOY)
    EVI_DL=make_array(n_elements(SOut[*,3]))  ; 
    for rr=0,LGP-1 do begin
      aaa=1./(1.+exp((parms[0]-(fix(pDOY)+rr))/parms[1]))-1./(1.+exp((parms[2]-(fix(pDOY)+rr))/parms[3]))
      if (aaa ge 0.9) then begin
        EVI_DL[rr]=0.9
        ;EVI_DL[0,rr]=fix(pDOY)+rr
      endif else begin
        EVI_DL[rr]=aaa
        ;EVI_DL[0,rr]=fix(pDOY)+rr
      endelse
    endfor

    ;计算 LTDG_DL-dEVI
    StatCal, data_mixing, SOut, nnum, EVI_DL, data_processing
    ;构建LEVIreference database
    LEVIreference.add,data_processing
  endfor
  ;print,n_elements(LEVIreference)

  ;(3)从 EVIreference 中选择 LEVIoptimized 并输出
  xx=DOYts_DL
  yy=EVIts_DL
  for jth=0,n_elements(LEVIreference)-1 do begin
    jLEVIref=LEVIreference[jth]
    jLEVIref_DOY=jLEVIref[0,*]  ; DOY
    jLEVIref_dEVI=jLEVIref[3,*]  ; dEVI
    ;common elements between xx and jLEVIref_DOY
    DOYcom=intersect(xx,jLEVIref_DOY)
    accdelta=0.0D
    accNum=0
    for ith=0,n_elements(DOYcom)-1 do begin
      ok1=where(xx eq DOYcom[ith],count)
      EVIobs=yy[ok1]
      ok2=where(jLEVIref_DOY eq DOYcom[ith],count)
      EVIpre=jLEVIref_dEVI[ok2]
      if (EVIpre gt 0) then begin
        delta=(EVIobs-EVIpre)^2
        accdelta=delta+accdelta
        accNum=accNum+1
      endif
    endfor
    RMSE=sqrt(accdelta/accNum)
    RMSE_array=[RMSE_array,RMSE]  ;补充新元素
  endfor
  print,"min(RMSE_array) is........................................",min(RMSE_array)
  print,'Landsat EVI observation Julian day:',xx
  print,'Landsat EVI observations:          ',yy
  
  ok3=where(RMSE_array eq min(RMSE_array),count)
  LEVIoptimized=LEVIreference[ok3[0]] 
  
  ; 判断最小RMSE是否符合要求：RMSE阈值为0.08
  ; 如果RMSE阈值高于0.08且作物生活史内Landsat EVI有效值数目>=8（暂定为8），认为成熟期DL函数重建效果要好于LTDG，因此考虑该阶段DL重建结果为最有输出值
  ; 判断LTDG EVI时序和DL EVI时序相交点，二者相差数值<=0.01对应的DOY
  ; DOY0.01之后的DL-EVI时序替换对应时段的LTDG-EVI时序
  ;;minRMSE=min(RMSE_array)
  ;;if (No_CropEVIibs ge 8 && minRMSE ge 0.08) then begin
    ;;Delta_Array=abs(LEVIoptimized[6,*] - LEVIoptimized[7,*])   ; DL-EVI时序减去LTDG-EVI时序
    ;;Tolerance_index=where(Delta_Array le 0.01, count)  
    ;;if count gt 1 then begin  ;DL-EVI时序和LTDG-EVI时序数组间存在至少2个近似值元素
      ;;DOYarray=LEVIoptimized[0,*]
      ;help,DOYarray
      ;;DOY_tolerance_array=DOYarray[Tolerance_index]  ; DOT_tolerance为一维数组
      ;help,DOY_tolerance_array
      ;;DOYmax=DOYarray[where(LEVIoptimized[7,*] eq max(LEVIoptimized[7,*]))]
      ;help,DOYmax
      ;;ididid=where(DOY_tolerance_array gt DOYmax[0], count)
      ;;DOY_tolerance=DOY_tolerance_array[ididid[0]]  
      ;;idid=where(DOYarray eq DOY_tolerance)
      ;;length=n_elements(DOYarray)-2
      ;;LEVIoptimized[3,idid:length]=LEVIoptimized[6,idid:length]  ; 成熟期DL-EVI时序替换该时段LTDG_DL EVI时序
    ;;endif
  ;;endif

  ; Save LEVIoptimized
  ;输入每个像元重建EVI时序文件
  ;以行( jjj + 1 )列( iii + 1 )号来命名文件
  filename2=strcompress(strtrim(strtrim(string(jjj+1),1)+'-'+strtrim(string(iii+1),1),1))+'_EVIsim.csv'
  Write_CSV,workDir+filename2,LEVIoptimized
  
  close, /all
end


;-------------------<MAIN PROGRAM>-----------------------------------------------------------
;  GLDAS2.0气象数据在R语言程序提前重采样至30m，Geotif格式 ，参考坐标系为UTM                               
;  ...dir+'\EVImap\'   ;子文件夹存储Landsat EVI全幅影像，参考坐标系为UTM
;  ...dir+'\GLDAS\SR\Cropimage'    ;存储已经裁剪好的ROI 30m分辨率GLDAS入射辐射数据序列，参考坐标系为UTM
;  ...dir+'\GLDAS\Tair\Cropimage'  ;存储已经裁剪好的ROI 30m分辨率GLDAS日气温数据序列，参考坐标系为UTM
;  Clipmap_dir1.txt存放裁剪好的Landsat EVI影像和土地利用影像路径地址,存放在dir主路径下
;  Crop.inf存放在dir主路径
;  ...dir\Results文件夹存放EVI重建时序csv和RMSE.txt文档
;  Landsat EVI影像像元的NA数值被定义为 -3.4000000e+038
;  Tbase=5oC,针对温带作物
;--------------------------------------------------------------------------------------------
pro LTDG_DL_Parallel_Region
  COMPILE_OPT IDL2   ;;更改IDL的编译配置
  
  dir='D:\Apple\R\practice\Shandong_SummerCrop'
  cd,dir
  
  ;先读入区域Landsat EVI影像、土地利用分类、日气象和作物信息
  Regional_meteor_ld_landsatEVI_crop_Information,EVIobsDOY_array,ldArray,DOYini_DL,DOYend_DL,DOYini_LTDG,DOYend_LTDG, $
                                     Tbase,x1x3,DOYie_LTDG,ncol,nrow,DOYarray_meteor,dir,SRArray_list,TairArray_list,EVIArray_list
  
  threads=8  ; 8核CPU
  ppp=objarr(threads)  ;构建对象数组Nroute，不同元素代表不同线程
  compile_command='.compile -v F:\LandsatEVIRubuilt\LTDG_DL_Shandong_Parallel.pro'   ;主程序路径
  ;任务数量统计
  start_col=1227
  end_col=1260
  task_number=(end_col-start_col+1)*nrow
  task_i=0
  counter_N=0
  for threads_i=0,threads-1 do begin    
    ;;创建多线程
    ppp[threads_i]=obj_new('IDL_IDLBridge')
    ppp[threads_i]->execute,compile_command   ; 编译主文件
    ;设置参数(只能是标量或者数组，不能是结构、指针等类型)并传递给子线程
    ppp[threads_i]->setvar,'dir',dir
    ppp[threads_i]->setvar,'DOYini_LTDG',DOYini_LTDG
    ppp[threads_i]->setvar,'DOYend_LTDG',DOYend_LTDG
    ppp[threads_i]->setvar,'Tbase',Tbase
    ppp[threads_i]->setvar,'DOYarray_meteor',DOYarray_meteor
    ppp[threads_i]->setvar,'x1x3',x1x3
    ;
    aloiss:
      iii=start_col
      jjj=task_i
      ldID=ldArray[iii,jjj]
      ;判定是否是农业用地
      if (ldID eq 12 || ldID eq 11) then begin
        print,'This is crop pixel!!!'
        ;初始化像元DOY和EVI一维数组、像元气象数据时序和生长季总有效积温
        DOYts_DL=[]
        EVIts_DL=[]
        DOYts_LTDG=[]
        EVIts_LTDG=[]
        GSaccGDDs=0.0  ; 
        SRarray_meteor=[]
        Tairarray_meteor=[]      
        ;确定像元气象数据时序
        for p=0,n_elements(DOYarray_meteor)-1 do begin
          DOY_meteor=DOYarray_meteor[p]
          ;太阳辐射
          index3=where(DOYarray_meteor eq DOY_meteor)
          SRarray=SRArray_list[index3[0]]
          SR=SRarray[iii,jjj]
          if (SR lt 0) then begin
            SR=12.0
          endif
          SRarray_meteor=[SRarray_meteor,SR]
          ;日均气温
          Tairarray=TairArray_list[index3[0]]
          Tair=Tairarray[iii,jjj]
          if Tair lt -10.0 then begin
            Tair=-10.0
          endif
          Tairarray_meteor=[Tairarray_meteor,Tair]
          ;从 DOYini_LTDG 开始计算有效积温，直至 DOYend_LTDG
          if (DOY_meteor ge DOYini_LTDG && DOY_meteor le DOYend_LTDG) then begin
            iGDD=Tair-Tbase
            if iGDD le 0.0 then iGDD=0.0
            GSaccGDDs=GSaccGDDs+iGDD
          endif
        endfor
        print,'Growing season total AccGDDs is: ',GSaccGDDs
        if (GSaccGDDs lt 820.0) then begin
          print,'Growing season total AccGDDs is too low, please check GLDAS input Tair data!!!'
          task_i+=1
          if task_i eq nrow-1 then begin
            start_col+=1
            task_i=0
          endif
          goto,aloiss    ; 生长季有效积温不小于820
        endif
        for k=0,n_elements(EVIobsDOY_array)-1 do begin
          doy_tempo=EVIobsDOY_array[k]
          ;确定DL重建函数所需要的DOY和对应的EVI信息
          if (doy_tempo ge DOYini_DL && doy_tempo le DOYend_DL) then begin
            index1=where(EVIobsDOY_array eq doy_tempo)   ; doy_tempo是第几个元素，where返回值是向量vector
            doy_tempo_EVIarray=EVIArray_list[index1[0]]
            EVI_pixel=doy_tempo_EVIarray[iii,jjj]
            ;确定EVI值是有效数值
            if EVI_pixel gt 0.9 then EVI_pixel=0.9
            if (EVI_pixel ge 0.01 && EVI_pixel lt 0.999) then begin
              DOYts_DL=[DOYts_DL,doy_tempo]
              EVIts_DL=[EVIts_DL,EVI_pixel]
            endif
          endif
          ;确定LTDG重建函数所需要的DOY和对应的EVI信息
          if (doy_tempo ge DOYini_LTDG && doy_tempo le DOYend_LTDG) then begin
            index2=where(EVIobsDOY_array eq doy_tempo)   ; doy_tempo是第几个元素
            doy_tempo_EVIarray=EVIArray_list[index2[0]]
            EVI_pixel=doy_tempo_EVIarray[iii,jjj]
            ;确定EVI值是有效数值
            if EVI_pixel gt 0.9 then EVI_pixel=0.9
            if (EVI_pixel ge 0.01 && EVI_pixel lt 0.999) then begin
              DOYts_LTDG=[DOYts_LTDG,doy_tempo]
              EVIts_LTDG=[EVIts_LTDG,EVI_pixel]
            endif
          endif
        endfor
        ;设置参数并继续传递给子线程
        ppp[threads_i]->setvar,'GSaccGDDs',GSaccGDDs
        ppp[threads_i]->setvar,'DOYts_DL',DOYts_DL
        ppp[threads_i]->setvar,'EVIts_DL',EVIts_DL
        ppp[threads_i]->setvar,'SRarray_meteor',SRarray_meteor
        ppp[threads_i]->setvar,'Tairarray_meteor',Tairarray_meteor
        ppp[threads_i]->setvar,'iii',iii
        ppp[threads_i]->setvar,'jjj',jjj
        ppp[threads_i]->setvar,'EVIts_LTDG',EVIts_LTDG
        ppp[threads_i]->setvar,'DOYts_LTDG',DOYts_LTDG 
        ;编译子线程LTDG_DL_Algorithm
        counter_N+=1
        ppp[threads_i]->execute,'LTDG_DL_Algorithm,GSaccGDDs,DOYts_LTDG,EVIts_LTDG,DOYts_DL,EVIts_DL,DOYarray_meteor,SRarray_meteor,Tairarray_meteor,DOYini_LTDG,DOYend_LTDG,Tbase,iii,jjj,x1x3,dir,counter_N',/nowait           
        task_i+=1
        if task_i eq nrow-1 then begin
          start_col+=1
          task_i=0
        endif
      endif else begin
        task_i+=1
        if task_i eq nrow-1 then begin
          start_col+=1
          task_i=0
        endif
        goto,aloiss
      endelse
    print,'task_i is:',task_i
  endfor
  
  ;查看子线程状态
  ;将新任务交给空子线程
  single=intarr(threads)
  while 1 gt 0 do begin
    for single_i=0,threads-1 do single[single_i]=ppp[single_i]->status()
    if (total(single) eq 0) then break
    child=where(single eq 0,child_count)
    if child_count gt 0 then begin
      for child_i=0,child_count-1 do begin
        threads_i_free=child[child_i]
        if start_col eq end_col then break
        ;设置参数(只能是标量或者数组，不能是结构、指针等类型)并传递给子线程
        ppp[threads_i_free]->setvar,'dir',dir
        ppp[threads_i_free]->setvar,'DOYini_LTDG',DOYini_LTDG
        ppp[threads_i_free]->setvar,'DOYend_LTDG',DOYend_LTDG
        ppp[threads_i_free]->setvar,'Tbase',Tbase
        ppp[threads_i_free]->setvar,'DOYarray_meteor',DOYarray_meteor
        ppp[threads_i_free]->setvar,'x1x3',x1x3
        ;
        aloisss:
        iii=start_col
        jjj=task_i
        ldID=ldArray[iii,jjj]
        ;判定是否是农业用地
        if (ldID eq 12 || ldID eq 11) then begin
          print,'This is crop pixel!!!'
          ;初始化像元DOY和EVI一维数组、像元气象数据时序和生长季总有效积温
          DOYts_DL=[]
          EVIts_DL=[]
          DOYts_LTDG=[]
          EVIts_LTDG=[]
          GSaccGDDs=0.0  ;
          SRarray_meteor=[]
          Tairarray_meteor=[]
          ;确定像元气象数据时序
          for p=0,n_elements(DOYarray_meteor)-1 do begin
            DOY_meteor=DOYarray_meteor[p]
            ;太阳辐射
            index3=where(DOYarray_meteor eq DOY_meteor)
            SRarray=SRArray_list[index3[0]]
            SR=SRarray[iii,jjj]
            if (SR lt 0) then begin
              SR=12.0
            endif
            SRarray_meteor=[SRarray_meteor,SR]
            ;日均气温
            Tairarray=TairArray_list[index3[0]]
            Tair=Tairarray[iii,jjj]
            if Tair lt -10.0 then begin
              Tair=-10.0
            endif
            Tairarray_meteor=[Tairarray_meteor,Tair]
            ;从 DOYini_LTDG 开始计算有效积温，直至 DOYend_LTDG
            if (DOY_meteor ge DOYini_LTDG && DOY_meteor le DOYend_LTDG) then begin
              iGDD=Tair-Tbase
              if iGDD le 0.0 then iGDD=0.0
              GSaccGDDs=GSaccGDDs+iGDD
            endif
          endfor
          print,'Growing season total AccGDDs is: ',GSaccGDDs
          if (GSaccGDDs lt 820.0) then begin
            print,'Growing season total AccGDDs is too low, please check GLDAS input Tair data!!!'
            task_i+=1
            if task_i eq nrow-1 then begin
              start_col+=1
              task_i=0
            endif
            goto,aloisss    ; 生长季有效积温不小于820
          endif
          for k=0,n_elements(EVIobsDOY_array)-1 do begin
            doy_tempo=EVIobsDOY_array[k]
            ;确定DL重建函数所需要的DOY和对应的EVI信息
            if (doy_tempo ge DOYini_DL && doy_tempo le DOYend_DL) then begin
              index1=where(EVIobsDOY_array eq doy_tempo)   ; doy_tempo是第几个元素，where返回值是向量vector
              doy_tempo_EVIarray=EVIArray_list[index1[0]]
              EVI_pixel=doy_tempo_EVIarray[iii,jjj]
              ;确定EVI值是有效数值
              if EVI_pixel gt 0.9 then EVI_pixel=0.9
              if (EVI_pixel ge 0.01 && EVI_pixel lt 0.999) then begin
                DOYts_DL=[DOYts_DL,doy_tempo]
                EVIts_DL=[EVIts_DL,EVI_pixel]
              endif
            endif
            ;确定LTDG重建函数所需要的DOY和对应的EVI信息
            if (doy_tempo ge DOYini_LTDG && doy_tempo le DOYend_LTDG) then begin
              index2=where(EVIobsDOY_array eq doy_tempo)   ; doy_tempo是第几个元素
              doy_tempo_EVIarray=EVIArray_list[index2[0]]
              EVI_pixel=doy_tempo_EVIarray[iii,jjj]
              ;确定EVI值是有效数值
              if EVI_pixel gt 0.9 then EVI_pixel=0.9
              if (EVI_pixel ge 0.01 && EVI_pixel lt 0.999) then begin
                DOYts_LTDG=[DOYts_LTDG,doy_tempo]
                EVIts_LTDG=[EVIts_LTDG,EVI_pixel]
              endif
            endif
          endfor
          ;设置参数并继续传递给子线程
          ppp[threads_i_free]->setvar,'GSaccGDDs',GSaccGDDs
          ppp[threads_i_free]->setvar,'DOYts_DL',DOYts_DL
          ppp[threads_i_free]->setvar,'EVIts_DL',EVIts_DL
          ppp[threads_i_free]->setvar,'SRarray_meteor',SRarray_meteor
          ppp[threads_i_free]->setvar,'Tairarray_meteor',Tairarray_meteor
          ppp[threads_i_free]->setvar,'iii',iii
          ppp[threads_i_free]->setvar,'jjj',jjj
          ppp[threads_i_free]->setvar,'EVIts_LTDG',EVIts_LTDG
          ppp[threads_i_free]->setvar,'DOYts_LTDG',DOYts_LTDG
          ;编译子线程LTDG_DL_Algorithm
          counter_N+=1
          ppp[threads_i_free]->execute,'LTDG_DL_Algorithm,GSaccGDDs,DOYts_LTDG,EVIts_LTDG,DOYts_DL,EVIts_DL,DOYarray_meteor,SRarray_meteor,Tairarray_meteor,DOYini_LTDG,DOYend_LTDG,Tbase,iii,jjj,x1x3,dir,counter_N',/nowait
          task_i+=1
          if task_i eq nrow-1 then begin
            start_col+=1
            task_i=0
          endif          
        endif else begin
          task_i+=1
          if task_i eq nrow-1 then begin
            start_col+=1
            task_i=0
          endif
          goto,aloisss
        endelse
        print,'task_i is:',task_i
      endfor
    endif
  endwhile
  
  for ippp=0,threads-1 do obj_destroy,ppp[ippp]
  
  
END ; END PROGRAM
